> ## Documentation Index
> Fetch the complete documentation index at: https://docs.campfire.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Revenue Transaction

> Create a new revenue transaction



## OpenAPI

````yaml https://api.meetcampfire.com/api/schema?format=json post /rr/api/v1/transactions
openapi: 3.0.3
info:
  title: Campfire Developer APIs
  version: 1.0.0
  description: >
    ## Introduction

    Campfire's developer APIs offer granular access to Campfire's core
    accounting,

    revenue recognition, and financial data features.


    These APIs are designed to be used by developers to build custom
    integrations,

    automate workflows, and perform any other programmatic operations.
servers:
  - url: https://api.meetcampfire.com
    description: Production server
security: []
tags:
  - name: Cash Management
    description: Operations related to accounts, transactions, and other bank-related data.
  - name: Core Accounting
    description: >-
      Operations related to core accounting data, such as the chart of accounts,
      entity management, and the general ledger.
  - name: Revenue Recognition
    description: >-
      Operations related to revenue recognition, contract management, and
      contract data aggregation.
  - name: Accounts Receivable
    description: Operations related to invoicing and the AR subledger
  - name: Accounts Payable
    description: Operations related to billing and the AP subledger.
  - name: Financial Statements
    description: Operations related to financial statement generation and data aggregation.
  - name: Settings
    description: Operations related to system and accounting settings configuration.
paths:
  /rr/api/v1/transactions:
    post:
      tags:
        - Revenue Recognition
      summary: Create Revenue Transaction
      description: Create a new revenue transaction
      operationId: create_revenue_transaction
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RevenueTransaction'
          application/x-www-form-urlencoded:
            schema:
              $ref: '#/components/schemas/RevenueTransaction'
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/RevenueTransaction'
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RevenueTransaction'
          description: ''
      security:
        - knoxApiToken: []
components:
  schemas:
    RevenueTransaction:
      type: object
      properties:
        id:
          type: integer
          readOnly: true
        is_deleted:
          type: boolean
          readOnly: true
          default: false
        deleted_at:
          type: string
          format: date-time
          readOnly: true
          nullable: true
        entity_name:
          type: string
          readOnly: true
        entity_currency:
          type: string
          readOnly: true
        client_name:
          type: string
          readOnly: true
        contract_name:
          type: string
          readOnly: true
        contract_status:
          type: string
          readOnly: true
        product_name:
          type: string
          readOnly: true
        product_bundle_name:
          type: string
          readOnly: true
        product_is_taxable:
          type: boolean
          readOnly: true
        contract_identifier:
          type: string
          readOnly: true
        client_identifier:
          type: string
          readOnly: true
        product_identifier:
          type: string
          readOnly: true
        gross_amount:
          type: string
          readOnly: true
        invoice_number:
          type: string
          readOnly: true
        invoice_date:
          type: string
          readOnly: true
        invoice_payment_status:
          type: string
          readOnly: true
        invoice_voided_date:
          type: string
          format: date
          readOnly: true
        credit_memo_number:
          type: string
          readOnly: true
        credit_memo_date:
          type: string
          format: date
          readOnly: true
        credit_memo_voided_date:
          type: string
          format: date
          readOnly: true
        credit_memo_application_status:
          type: string
          readOnly: true
        revenue_type:
          type: string
          readOnly: true
        journal_entry_order:
          type: string
          readOnly: true
        contract_subscription_notes:
          type: string
          readOnly: true
        department_name:
          type: string
          readOnly: true
        parent_department_name:
          type: string
          readOnly: true
        parent_department:
          type: integer
          readOnly: true
        tags:
          type: string
        usage_tier_name:
          type: string
          readOnly: true
        last_modified_at:
          type: string
          format: date-time
          readOnly: true
        anrok_item_id:
          type: string
          readOnly: true
        sphere_item_id:
          type: string
          readOnly: true
        source:
          type: string
          nullable: true
          maxLength: 250
        description:
          type: string
          nullable: true
        external_id:
          type: string
          nullable: true
          maxLength: 250
        client_external_id:
          type: string
          nullable: true
          maxLength: 250
        contract_external_id:
          type: string
          nullable: true
          maxLength: 250
        contract_subscription_external_id:
          type: string
          nullable: true
          maxLength: 250
        product_external_id:
          type: string
          nullable: true
          maxLength: 250
        accounting_period:
          type: string
          format: date
          nullable: true
        transaction_date:
          type: string
          format: date
          nullable: true
        transaction_end_date:
          type: string
          format: date
          nullable: true
        currency:
          type: string
          maxLength: 3
        exchange_rate:
          type: number
          format: double
          maximum: 100000000000000
          minimum: -100000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        exchange_rate_book:
          type: number
          format: double
          maximum: 100000000000000
          minimum: -100000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        recognized:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        amount:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        quantity:
          type: number
          format: double
          maximum: 100000000000000
          minimum: -100000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        rate:
          type: number
          format: double
          maximum: 10000000000000
          minimum: -10000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        discount:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        refunds:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        processing_fees:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        platform_fees:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        transfers:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        tax:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        balance_adjustment:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
          description: >-
            Invoice starting balance or other balance adjustments (e.g.,
            previous balance applied to this transaction)
        mrr:
          type: number
          format: double
          maximum: 1000000000000000000
          minimum: -1000000000000000000
          exclusiveMaximum: true
          exclusiveMinimum: true
          nullable: true
        renewall:
          type: boolean
        tag_ids:
          type: array
          items:
            type: integer
            maximum: 9223372036854776000
            minimum: -9223372036854776000
            format: int64
        tag_group_ids:
          type: array
          items:
            type: integer
            maximum: 9223372036854776000
            minimum: -9223372036854776000
            format: int64
        is_migration_invoiced:
          type: boolean
          description: >-
            Marked as invoiced during migration. Does not create GL entries or
            AR.
        created_at:
          type: string
          format: date-time
          readOnly: true
          nullable: true
        customer:
          type: integer
          readOnly: true
        entity:
          type: integer
          nullable: true
        client:
          type: integer
          nullable: true
        contract:
          type: integer
          nullable: true
        contract_subscription:
          type: integer
          nullable: true
        non_contract_subscription:
          type: integer
          nullable: true
        contract_usage:
          type: integer
          nullable: true
        contract_milestone:
          type: integer
          nullable: true
        non_contract_usage:
          type: integer
          nullable: true
        prepaid_commit:
          type: integer
          nullable: true
        product:
          type: integer
          nullable: true
        product_bundle:
          type: integer
          nullable: true
        contract_product_bundle:
          type: integer
          nullable: true
          description: Reference to contract-specific editable product bundle allocation
        contract_bundle:
          type: integer
          nullable: true
        journal_entry:
          type: integer
          nullable: true
        invoice:
          type: integer
          nullable: true
        credit_memo:
          type: integer
          nullable: true
        department:
          type: integer
          nullable: true
        usage_tier:
          type: integer
          nullable: true
      required:
        - anrok_item_id
        - client_identifier
        - client_name
        - contract_identifier
        - contract_name
        - contract_status
        - contract_subscription_notes
        - created_at
        - credit_memo_application_status
        - credit_memo_date
        - credit_memo_number
        - credit_memo_voided_date
        - customer
        - deleted_at
        - department_name
        - entity_currency
        - entity_name
        - gross_amount
        - id
        - invoice_date
        - invoice_number
        - invoice_payment_status
        - invoice_voided_date
        - is_deleted
        - journal_entry_order
        - last_modified_at
        - parent_department
        - parent_department_name
        - product_bundle_name
        - product_identifier
        - product_is_taxable
        - product_name
        - revenue_type
        - sphere_item_id
        - usage_tier_name
  securitySchemes:
    knoxApiToken:
      type: apiKey
      in: header
      name: Authorization
      description: Token-based authentication with required prefix "Token"

````